# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Redis.V1.Model.ClusterSlots do
  @moduledoc """
  A series of slots belonging to a cluster.

  ## Attributes

  *   `endSlotsExclusive` (*type:* `integer()`, *default:* `nil`) - Output only. The end of the slots that make up this series.
  *   `memorySizeGb` (*type:* `integer()`, *default:* `nil`) - Output only. The total size of keyspace this series has.
  *   `replicaCount` (*type:* `integer()`, *default:* `nil`) - Output only. The number of replicas this series has.
  *   `startSlotsInclusive` (*type:* `integer()`, *default:* `nil`) - Output only. The start of the slots that make up this series.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :endSlotsExclusive => integer() | nil,
          :memorySizeGb => integer() | nil,
          :replicaCount => integer() | nil,
          :startSlotsInclusive => integer() | nil
        }

  field(:endSlotsExclusive)
  field(:memorySizeGb)
  field(:replicaCount)
  field(:startSlotsInclusive)
end

defimpl Poison.Decoder, for: GoogleApi.Redis.V1.Model.ClusterSlots do
  def decode(value, options) do
    GoogleApi.Redis.V1.Model.ClusterSlots.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Redis.V1.Model.ClusterSlots do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
